%Teilfaltung mit P Blcken der Lnge M
%%%%%%%%%%%%%%%%%%%%%%%%

%IR erstellen
%%%%%%%%%%%%%%%%%%%%%%%%
%Parameter definieren
[h,Fh]=wavread('theater_16kHz.wav');  %IR einlesen
hl=h(:,1);
M=numel(hl);                   %Gesamtlnge der Impulsantwort
hopsize=512;            %Lnge des Teilblocks VARIABEL
P=ceil(M/hopsize);                    %Anzahl der Blcke (spalten)

n=1:M;                  %Zeitarray erzeugen (Anzahl der Stellen)
p=1:P;                  %Blockindex

%Zerlegung der IR
%%%%%%%%%%%%%%%%%%%%%%%%%
g=zeros(2*hopsize,P);   %Zeropadding

l=1;                    %Spaltenzhler init.
k=1;                    %Zeilenzhler init.
t=1;
while t<=M
    while k<=hopsize
    if t<=M
       g(k,l)=hl(t);
    end
       k=k+1;
     
          t=t+1;
     
    end
    
    k=1;
    l=l+1;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%FFT der einzelnen Impulsantworten
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
u=1;
while u<=P
    Spektrum(:,u)=fft(g(:,u),2*hopsize);
    u=u+1;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%erstellen Aufteilung des EIngangsignals in Teilfolgen der Lnge "hopsize"
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[in_LR, Fx]=wavread('ahhh_16kHz.wav');
in=in_LR(:,1);      %in 'in' wird nur 1 Kanal gespeichert
r=ceil(numel(in)/hopsize);                 %Anzahl der Blcke (Eingang)
%in(r)=[ones(numel(in),1)];      %Eingangssignal erzeugen


l=1;                    %Spaltenzhler init.
k=1;                    %Zeilenzhler init.
t=1;
z=zeros(2*hopsize,P);      %Zeropadding Eingangssignal

while l<=numel(in)/hopsize %Eingang in Teilblcke zerlegen
    while k<=hopsize
       z(k,l)=in(t);    
       k=k+1;
       t=t+1;
    end
    
    k=1;
    l=l+1;
end

while 2*k<=numel(z)/(2*hopsize) 
    z_complex(:,k)=[z(:,2*k-1)+1i*z(:,2*k)];    %Teilblcke zu komplexe Teilblcke sortiert
    k=k+1;
end

u=1;
while u<=numel(z_complex)/(2*hopsize)
    Spektrum_eingang(:,u)=fft(z_complex(:,u),2*hopsize); %komplexe FFT der komplexen Teilblcke
    u=u+1;
end
y1=zeros(M+numel(in)+1,1);             %Ausgabevektor erzeugen
tic;            
for global_counter=1:1:(fix(r/2)-1)        %Index fr des zu bearbeitenden Eingangsblock
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Punktweise Multiplikation der Spektren%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
u=1; %zhler init.
k=1;
while k<=P
    for u=1:1:P
        Teilfaltung_spektrum(:,u,global_counter)=Spektrum_eingang(:,global_counter).*Spektrum(:,u);
       % u=u+1;
    end
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %IFFT der Teilfaltungen (in Schleife eingebettet) 
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    Teilfaltung(:,k,global_counter)=ifft(Teilfaltung_spektrum(:,k,global_counter),2*hopsize);
    
    k=k+1;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Bestimmung der Teilfaltung
%Realteil=ungerader Eingangsblock gefaltet mit IR
%Imgainrteil=gerader Eingangsblock gefaltet mit IR
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for u=1:1:P

    a(:,u)=real(Teilfaltung(:,u,global_counter));
    b(:,u)=imag(Teilfaltung(:,u,global_counter));
    
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Matrix in Vektor umformen
%siehe Schema Zlzer S.175
%erster teil wird hingeschrieben -> index um 1x hopsize veringern und
%nchsten Teil rauf addieren
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

A=zeros((P+1)*hopsize,1);    %gerader ausgabevektor 
B=zeros((P+1)*hopsize,1);    %ungerader ausgabevektor 
k=1;        %Stelle des Ausgangsvektors
l=1;        %Spaltenzhler
u=1;        %Zeilenzhler
%%%%%%%%%%%%%%%%%%%%
%Faltung mit ungeraden Eingangsblock Y=X(2i-1)*H
%%%%%%%%%%%%%%%%%%%%
while k<=hopsize*(P+1)
    if u>2*hopsize
        u=1;
        l=l+1;
        k=k-hopsize;
    end
    if l<=numel(a)/(2*hopsize)
        A(k)=A(k)+a(u,l);
    end
        k=k+1;
       u=u+1;
              
    
end
%%%%%%%%%%%%%%%%%%%%%
%Faltung mit geraden Eingangsblock Y=X(2*i)*H
%%%%%%%%%%%%%%%%%%%%%
k=1;
l=1;
u=1;

while k<hopsize*(P+1)
    if u>2*hopsize
        u=1;
        l=l+1;
        k=k-hopsize;
    end
    if l<=numel(b)/(2*hopsize)
        B(k)=B(k)+b(u,l);
    end
    
    k=k+1;
    u=u+1;
              
    
end
%%%%%%%%%%%%%%%%%%%%%%
%Ausgabevektor init.
%%%%%%%%%%%%%%%%%%%%%%
 
y=zeros(numel(A)+hopsize,1);   
%%%%%%%%%%%%%%%%%%%%%%%%
%Zusammenfgen der ungeraden und geraden Teilfaltung A,B
   
for k=1:1:(P+2)*hopsize%/2 %ACHTUNG!!!
    if k>numel(A)
        y(k)=B(k-hopsize);
    else
    
    if k-hopsize<1
        y(k)=y(k)+A(k);
    
        
    else
        y(k)=y(k)+A(k)+B(k-hopsize);
    end
    end
    %Endergebniss wird in y1 geschrieben
   % if k-2*(global_counter-1)*hopsize>1
        y1(k+2*(global_counter-1)*hopsize)=y1(k+2*(global_counter-1)*hopsize)+y(k);
    %end 
end

toc
   
end


Ausgabe=transpose(y1)/max(abs(y1));